Index: /pjproject/trunk/build.symbian/bld.inf
===================================================================
--- /pjproject/trunk/build.symbian/bld.inf	(revision 2675)
+++ /pjproject/trunk/build.symbian/bld.inf	(revision 2676)
@@ -24,4 +24,7 @@
 libpassthroughcodec.mmp
 
+/* Resample */
+libresample.mmp
+
 /* Audio device. */
 pjmedia_audiodev.mmp
Index: /pjproject/trunk/build.symbian/libresample.mmp
===================================================================
--- /pjproject/trunk/build.symbian/libresample.mmp	(revision 2676)
+++ /pjproject/trunk/build.symbian/libresample.mmp	(revision 2676)
@@ -0,0 +1,25 @@
+TARGET 		libresample.lib
+TARGETTYPE 	lib
+
+SOURCEPATH	..\third_party\resample\src
+
+//
+// GCCE optimization setting
+//
+OPTION		GCCE -O2 -fno-unit-at-a-time
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+
+MACRO       	RESAMPLE_HAS_SMALL_FILTER=1
+MACRO       	RESAMPLE_HAS_LARGE_FILTER=0
+
+SOURCE		resamplesubs.c
+
+SYSTEMINCLUDE	..\third_party\resample\include
+SYSTEMINCLUDE	..\third_party\build\resample
+
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+
+
Index: /pjproject/trunk/build.symbian/pjmedia.mmp
===================================================================
--- /pjproject/trunk/build.symbian/pjmedia.mmp	(revision 2675)
+++ /pjproject/trunk/build.symbian/pjmedia.mmp	(revision 2676)
@@ -99,4 +99,5 @@
 SYSTEMINCLUDE	..\third_party\srtp\crypto\include
 SYSTEMINCLUDE	..\third_party\build\srtp
+SYSTEMINCLUDE	..
 
 SYSTEMINCLUDE	\epoc32\include
Index: /pjproject/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- /pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 2675)
+++ /pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 2676)
@@ -45,4 +45,5 @@
 STATICLIBRARY		pjlib_util.lib pjlib.lib
 STATICLIBRARY		libsrtp.lib
+STATICLIBRARY		libresample.lib
 
 #if SND_HAS_APS
Index: /pjproject/trunk/pjlib/include/pj/config_site_sample.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 2675)
+++ /pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 2676)
@@ -134,6 +134,15 @@
     #define PJMEDIA_HAS_SPEEX_AEC		0
 
-    /* Shouldn't use resampling for performance reason too. */
-    #define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_NONE
+    /* Previously, resampling is disabled due to performance reason and
+     * this condition prevented some 'light' wideband codecs (e.g: G722.1)
+     * to work along with narrowband codecs. Lately, some tests showed
+     * that 16kHz <-> 8kHz resampling using libresample small filter was 
+     * affordable on ARM9 222 MHz, so here we decided to enable resampling.
+     * Note that it is important to make sure that libresample is created
+     * using small filter. For example PJSUA_DEFAULT_CODEC_QUALITY must
+     * be set to 3 or 4 so pjsua-lib will apply small filter resampling.
+     */
+    //#define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_NONE
+    #define PJMEDIA_RESAMPLE_IMP		PJMEDIA_RESAMPLE_LIBRESAMPLE
 
     /* Use the lighter WSOLA implementation */
@@ -173,6 +182,8 @@
      */
 
-    /* Default codec quality */
-    #define PJSUA_DEFAULT_CODEC_QUALITY		5
+    /* Default codec quality, previously was set to 5, however it is now
+     * set to 4 to make sure pjsua instantiates resampler with small filter.
+     */
+    #define PJSUA_DEFAULT_CODEC_QUALITY		4
 
     /* Set maximum number of dialog/transaction/calls to minimum */
Index: /pjproject/trunk/pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp
===================================================================
--- /pjproject/trunk/pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp	(revision 2675)
+++ /pjproject/trunk/pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp	(revision 2676)
@@ -46,4 +46,5 @@
 STATICLIBRARY	libspeexcodec.lib
 STATICLIBRARY	libg7221codec.lib
+STATICLIBRARY	libresample.lib
 
 
Index: /pjproject/trunk/third_party/build/resample/config.h
===================================================================
--- /pjproject/trunk/third_party/build/resample/config.h	(revision 2675)
+++ /pjproject/trunk/third_party/build/resample/config.h	(revision 2676)
@@ -1,3 +1,7 @@
-#define RESAMPLE_HAS_SMALL_FILTER	1
-#define RESAMPLE_HAS_LARGE_FILTER	1
+#ifndef RESAMPLE_HAS_SMALL_FILTER
+#   define RESAMPLE_HAS_SMALL_FILTER	1
+#endif
 
+#ifndef RESAMPLE_HAS_LARGE_FILTER
+#   define RESAMPLE_HAS_LARGE_FILTER	1
+#endif