Index: pjproject/trunk/pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp
===================================================================
--- pjproject/trunk/pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp	(revision 2697)
+++ pjproject/trunk/pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp	(revision 2698)
@@ -1,32 +1,37 @@
-#define SND_USE_NULL	0
-#define SND_USE_APS	0
+#define SND_HAS_APS	0
+#define SND_HAS_VAS	0
+#define SND_HAS_MDA	1
 
 TARGET			symbian_ua_gui.exe
-UID			   0x100039CE 0xEBD12EE4
-VENDORID	  	  0
+UID			0x100039CE 0xEBD12EE4
+VENDORID	  	0
 TARGETTYPE		exe
-EPOCSTACKSIZE	0x8000
+EPOCSTACKSIZE		0x8000
 
-MACRO		PJ_M_I386=1
-MACRO		PJ_SYMBIAN=1
+MACRO			PJ_M_I386=1
+MACRO			PJ_SYMBIAN=1
 
-SYSTEMINCLUDE	\epoc32\include \epoc32\include\variant \epoc32\include\ecom
-SYSTEMINCLUDE	\epoc32\include\libc
-SYSTEMINCLUDE	..\..\..\..\pjlib\include
-SYSTEMINCLUDE	..\..\..\..\pjlib-util\include
-SYSTEMINCLUDE	..\..\..\..\pjnath\include
-SYSTEMINCLUDE	..\..\..\..\pjmedia\include
-SYSTEMINCLUDE	..\..\..\..\pjsip\include
+SYSTEMINCLUDE		\epoc32\include
+SYSTEMINCLUDE		\epoc32\include\variant 
+SYSTEMINCLUDE		\epoc32\include\ecom
+SYSTEMINCLUDE		\epoc32\include\libc
+SYSTEMINCLUDE		..\..\..\..\pjlib\include
+SYSTEMINCLUDE		..\..\..\..\pjlib-util\include
+SYSTEMINCLUDE		..\..\..\..\pjnath\include
+SYSTEMINCLUDE		..\..\..\..\pjmedia\include
+SYSTEMINCLUDE		..\..\..\..\pjsip\include
 
-USERINCLUDE	..\inc ..\data
+USERINCLUDE		..\inc 
+USERINCLUDE		..\data
 
 SOURCEPATH		..\data
-START RESOURCE	symbian_ua_gui.rss
+
+START RESOURCE		symbian_ua_gui.rss
 HEADER
-TARGETPATH resource\apps
+TARGETPATH 		resource\apps
 END //RESOURCE
 
-START RESOURCE	symbian_ua_gui_reg.rss
-TARGETPATH 	  \private\10003a3f\apps
+START RESOURCE		symbian_ua_gui_reg.rss
+TARGETPATH 	  	\private\10003a3f\apps
 END //RESOURCE
 
@@ -38,38 +43,51 @@
 LIBRARY			charconv.lib estlib.lib 
 
-STATICLIBRARY	pjsua_lib.lib pjsip_ua.lib
-STATICLIBRARY	pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib
-STATICLIBRARY	pjmedia_audiodev.lib
-STATICLIBRARY	pjnath.lib pjlib_util.lib pjlib.lib
-STATICLIBRARY	libsrtp.lib
-STATICLIBRARY	libgsmcodec.lib
-STATICLIBRARY	libspeexcodec.lib
-STATICLIBRARY	libg7221codec.lib
-STATICLIBRARY	libresample.lib
+STATICLIBRARY		pjsua_lib.lib pjsip_ua.lib
+STATICLIBRARY		pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib
+STATICLIBRARY		pjmedia_audiodev.lib
+STATICLIBRARY		pjnath.lib pjlib_util.lib pjlib.lib
+STATICLIBRARY		libsrtp.lib
+STATICLIBRARY		libgsmcodec.lib
+STATICLIBRARY		libspeexcodec.lib
+STATICLIBRARY		libg7221codec.lib
+STATICLIBRARY		libresample.lib
 
 
-#if SND_USE_NULL
-    STATICLIBRARY	null_audio.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment 
-#elif SND_USE_APS
-    LIBRARY			APSSession2.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment MultimediaDD
-    MACRO			PJMEDIA_SYM_SND_USE_APS=1
-#else
-    LIBRARY 		mediaclientaudiostream.lib
-    LIBRARY 		mediaclientaudioinputstream.lib
-    CAPABILITY		NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment 
+#if SND_HAS_APS
+	LIBRARY		APSSession2.lib
 #endif
 
-LANG 				01
+#if SND_HAS_VAS
+//	LIBRARY		
+#endif
 
-START BITMAP	symbian_ua_gui.mbm
+#if SND_HAS_MDA
+	LIBRARY 	mediaclientaudiostream.lib
+	LIBRARY 	mediaclientaudioinputstream.lib
+#endif
+
+#if SND_HAS_APS || SND_HAS_VAS
+	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment MultimediaDD
+#else
+	CAPABILITY	NetworkServices LocalServices ReadUserData WriteUserData UserEnvironment
+#endif
+
+LANG 			01
+
+START BITMAP		symbian_ua_gui.mbm
 HEADER
 TARGETPATH		\resource\apps
 SOURCEPATH		..\gfx
-SOURCE	c12,1	list_icon.bmp list_icon_mask.bmp
+SOURCE	c12,1		list_icon.bmp list_icon_mask.bmp
 END
 
 SOURCEPATH		..\src
-SOURCE symbian_ua_guiContainerView.cpp symbian_ua_guiContainer.cpp symbian_ua_guiAppUi.cpp symbian_ua_guiDocument.cpp symbian_ua_guiApplication.cpp symbian_ua_guiSettingItemList.cpp Symbian_ua_guiSettingItemListSets.cpp symbian_ua_guiSettingItemListView.cpp
-SOURCE symbian_ua.cpp
+SOURCE 			symbian_ua_guiContainerView.cpp 
+SOURCE 			symbian_ua_guiContainer.cpp 
+SOURCE 			symbian_ua_guiAppUi.cpp 
+SOURCE 			symbian_ua_guiDocument.cpp 
+SOURCE 			symbian_ua_guiApplication.cpp 
+SOURCE 			symbian_ua_guiSettingItemList.cpp 
+SOURCE 			Symbian_ua_guiSettingItemListSets.cpp 
+SOURCE 			symbian_ua_guiSettingItemListView.cpp
+SOURCE 			symbian_ua.cpp